<?php

require_once 'MysqlException.php';

class DB_Mysql {
  protected $user;
  protected $pass;
  protected $dbhost;
  protected $dbname;
  
  protected $dbh; // database connection handle
  
  public function __construct($user, $pass, $dbhost, $dbname) {
    $this->user = $user;
    $this->pass = $pass;
    $this->dbhost = $dbhost;
    $this->dbname = $dbname;     
  }
  
  protected function connect() {
    $this->dbh = mysql_pconnect($this->dbhost, $this->user, $this->pass);
    if (!is_resource($this->dbh)) {
      throw new MysqlException;
    }
    if (!mysql_select_db($this->dbname, $this->dbh)) {
      throw new MysqlException;
    }
  }
  
  public function execute($query) {
    if (!$this->dbh) {
      $this->connect();
    }
    $ret = mysql_query($query, $this->dbh);
    if (!$ret) {
      throw new MysqlException;
    }
    else if (!is_resource($ret)) {
      return TRUE;
    }
    else {
      $stmt = new DB_MysqlStatement($this->dbh, $query);
      $stmt->result = $ret;
      return $stmt;
    }
  }  
}

class DB_MysqlStatement {
  public $result;
  public $query;
  protected $dbh;
  
  public function __construct($dbh, $query) {
    $this->query = $query;
    $this->dbh = $dbh;
    if (!is_resource($dbh)) {
      throw new MysqlException("Spojení s databází se nezdařilo");
    }
  }
  
  public function fetch_row() {
    if (!$this->result) {
      throw new MysqlException("Dotaz nebyl vykonán");
    }
    return mysql_fetch_row($this->result);
  }
  
  public function fetch_assoc() {
    if (!$this->result) {
      throw new MysqlException("Dotaz nebyl vykonán");
    }
    return mysql_fetch_assoc($this->result);
  }
  
  public function fetchall_assoc() {
    $retval = array();
    while ($row = $this->fetch_assoc()) {
      $retval[] = $row;
    }
  }  
}

?>
